package linkdatamanager;
import hanabisetting.HanabiSettings;

import java.util.ArrayList;

import searcher.Searcher;
import cache.Cache;

public class LinkDataManager {

	private final String[] searchTag = HanabiSettings.SEARCH_ORDER; // 鏇ԂƉ񐔂w肷

	Searcher searcher = new Searcher();
	Cache cache = new Cache();

	public static void main(String[] args) {
		/*
		 * eXg LinkDataManager linkDataManager=new LinkDataManager(); LinkData
		 * linkData = new LinkData();
		 * linkData=linkDataManager.makeLinkData("vO~O", 3, 0, linkData);
		 * System.out.print(linkData.linkDataToString());
		 */
	}

	public LinkData makeLinkData(String key) {
		LinkData linkData = new LinkData();
		linkData = makeLinkData(key, (searchTag.length - 2), 0, linkData);
		return linkData;
	}

	public LinkData makeLinkData(String key, int searchLevel,
			int searchTagNumber, LinkData linkData) {
		String fromType = searchTag[searchTagNumber];
		String toType = searchTag[searchTagNumber + 1];
		HanabiSettings
				.debugPrint("search(key:" + key + "toType" + toType + ")");
		if (searchLevel == 0) {
			// Ȃ
		} else {
			ArrayList<String> list = searcher.search(key, toType);
			if (list == null) {// ʂԂĂȂ
				return null;
			} else {// ʂԂĂ

				if (!(isEmptyString(key))) {// ꂪ󔒕ǂׂ
					// Nf[^쐬
					for (String string : list) {
						if (!(isEmptyString(string))) {// ʂ󔒕ǂׂ
							linkData.addEdge(key, fromType, string, toType);
							makeLinkData(string, searchLevel - 1,
									searchTagNumber + 1, linkData);
						}
					}
				}
			}
		}

		return linkData;
	}
	private boolean isEmptyString(String text) {
		char[] textChars = text.toCharArray();
		for (char c : textChars) {
			if (!(c == ' ' || c == '\n' || c == '\r' || c == '@' || c == '\t')) {
				return false;
			}
		}
		return true;
	}
}
