package searcher;
import java.util.ArrayList;

import org.xml.sax.Attributes;
import org.xml.sax.helpers.DefaultHandler;

class FacultyHandler extends DefaultHandler {

	// pV[NGX
	private int sequence = 1;

	// ݂̃^O
	private String tagStatus = new String();

	// NG[
	private String query = new String();

	// ԋp啪샊Xg
	private ArrayList<String> fieldList = new ArrayList<String>();

	// cTag
	private final String FAMILY_NAME_TAG = "fname";

	//啪Tag
	private final String FIELD_NAME_TAG = "field";

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.xml.sax.helpers.DefaultHandler#startDocument()
	 */
	public void startDocument() {
		System.out.println("start XMLparse");
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.xml.sax.helpers.DefaultHandler#endDocument()
	 */
	public void endDocument() {
		System.out.println("end XMLparse");
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.xml.sax.helpers.DefaultHandler#startElement(java.lang.String,
	 *      java.lang.String, java.lang.String, org.xml.sax.Attributes)
	 */
	public void startElement(String uri, String localName, String qName,
			Attributes attrs) {
		// 𒲂ׂĂ邩m点
		tagStatus = qName;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.xml.sax.helpers.DefaultHandler#endElement(java.lang.String,
	 *      java.lang.String, java.lang.String, org.xml.sax.Attributes)
	 */
	public void endElement(String uri, String localName, String qName,
			Attributes attrs) {

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.xml.sax.helpers.DefaultHandler#characters(char[], int, int)
	 */
	public void characters(char[] ch, int offset, int length) {
		String element = new String(ch, offset, length);

		//肷
		if (sequence == 2) {
			if (tagStatus.equals(FIELD_NAME_TAG)) {
				if ((element.equals("\n") == false) || (element.equals(null) == false)) {
					setFieldList(element);
				}
			} else if (tagStatus.equals(FAMILY_NAME_TAG)) {
				sequence = 0;
			}
		}

		// c邩ׂ
		if (query.matches(element + ".*")
				&& (tagStatus.equals(FAMILY_NAME_TAG)) && sequence == 1) {
			System.out.println("a-?:a??");
			sequence++;
		}
	}

	// fieldList getter
	public ArrayList<String> getFieldList() {
		if (fieldList.size() == 0) {
			return null;
		} else {
			return fieldList;
		}
	}

	// fieldList setter
	public void setFieldList(String field) {
		this.fieldList.add(field);
	}

	// query setter
	public void setQuery(String query) {
		this.query = query;
	}
}